//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  Silver
#property indicator_color2  Silver
#property indicator_color3  Silver
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_color4  DeepSkyBlue
#property indicator_color5  Red
#property indicator_color6  Red

//
//
//
//
//

extern string TimeFrame   = "Current time frame";
extern int    SF          = 5;
extern int    RSIPeriod   = 14;
extern int    RSIPrice    = PRICE_CLOSE;
extern double WP          = 4.236;
//
//
//
//
//

double TrendU[];
double TrendDa[];
double TrendDb[];
double RsiMa[];
double RsiMaDa[];
double RsiMaDb[];
double TrendQqe[];
double TrendQqs[];
double emas[][3];
double dummy1[];
double dummy2[];
double ma[];
string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,RsiMa);    SetIndexLabel(0, "QQE");
   SetIndexBuffer(1,RsiMaDa);  SetIndexLabel(1, "QQE down");
   SetIndexBuffer(2,RsiMaDb);  SetIndexLabel(2, "QQE down");
   SetIndexBuffer(3,TrendU);   SetIndexLabel(1, "QQE trend up");
   SetIndexBuffer(4,TrendDa);  SetIndexLabel(2, "QQE trend down");
   SetIndexBuffer(5,TrendDb);  SetIndexLabel(2, "QQE trend down");
   SetIndexBuffer(6,dummy1);
   SetIndexBuffer(7,dummy2);
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
   
   IndicatorShortName(timeFrameToString(timeFrame)+" QQE ("+SF+","+RSIPeriod+")");
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define iEma 0
#define iEmm 1
#define iQqe 2

//
//
//
//
//

int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { RsiMa[0] = MathMin(limit+1,Bars-1); return(0); }
           if (ArrayRange(emas,0) != Bars) { ArrayResize(emas,Bars); ArrayResize(TrendQqe,Bars); ArrayResize(TrendQqs,Bars); ArrayResize(ma,Bars); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      if (TrendQqe[Bars-limit-1]==-1) CleanPoint(limit,RsiMaDa,RsiMaDb);
      if (TrendQqs[Bars-limit-1]==-1) CleanPoint(limit,TrendDa,TrendDb);
      double alpha1 = 2.0/(SF+1.0);
      double alpha2 = 2.0/(RSIPeriod*2.0);
      for (i=limit, r=Bars-i-1; i>=0; i--,r++)
      {  
         ma[r] = iMA(NULL,0,1,0,MODE_SMA,RSIPrice,i);
         double up     = 0;
         double down   = 0;
         double diff   = 0;
         double tmpRsi = 0;
         for(int k=0; k<RSIPeriod; k++)
         {
            diff = ma[r-k]-ma[r-k-1];
            if(diff>0)
                  up   += diff;
            else  down -= diff;
         }
         if(up+down== 0)
               tmpRsi = 50.0;
         else  tmpRsi = 100.0 * up / (up + down);         
   
      //
      //
      //
      //
      //
         
      RsiMa[i]   = RsiMa[i+1] + alpha1*(tmpRsi - RsiMa[i+1]);
      emas[r][iEma] = emas[r-1][iEma] + alpha2*(MathAbs(RsiMa[i+1]-RsiMa[i]) - emas[r-1][iEma]);
      emas[r][iEmm] = emas[r-1][iEmm] + alpha2*(emas[r][iEma] - emas[r-1][iEmm]);

      //
      //
      //
      //
      //

         double rsi0 = RsiMa[i];
         double rsi1 = RsiMa[i+1];
         double dar  = emas[r  ][iEmm]*WP;
         double tr   = emas[r-1][iQqe];
         double dv   = tr;
   
            if (rsi0 < tr) { tr = rsi0 + dar; if ((rsi1 < dv) && (tr > dv)) tr = dv; }
            if (rsi0 > tr) { tr = rsi0 - dar; if ((rsi1 > dv) && (tr < dv)) tr = dv; }
         
      //
      //
      //
      //
      //
         
         TrendU[i]     = tr;
         emas[r][iQqe] = tr;
         TrendDa[i]    = EMPTY_VALUE;
         TrendDb[i]    = EMPTY_VALUE;
         RsiMaDa[i]    = EMPTY_VALUE;
         RsiMaDb[i]    = EMPTY_VALUE;
         TrendQqe[r]   = TrendQqe[r-1];
         TrendQqs[r]   = TrendQqs[r-1];

            if (RsiMa[i]>RsiMa[i+1]) TrendQqe[r] =  1;
            if (RsiMa[i]<RsiMa[i+1]) TrendQqe[r] = -1;
            if (tr     < RsiMa[i]  ) TrendQqs[r] =  1;
            if (tr     > RsiMa[i]  ) TrendQqs[r] = -1;

         if (TrendQqe[r] == -1) PlotPoint(i,RsiMaDa,RsiMaDb,RsiMa);
         if (TrendQqs[r] == -1) PlotPoint(i,TrendDa,TrendDb,TrendU);
         if (calculateValue)
         {
            dummy1[i] = TrendQqe[r];
            dummy2[i] = TrendQqs[r];
         }
      }    
      return(0);
   }      

   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      if (TrendQqe[Bars-limit-1]==-1) CleanPoint(limit,RsiMaDa,RsiMaDb);
      if (TrendQqs[Bars-limit-1]==-1) CleanPoint(limit,TrendDa,TrendDb);
      for (i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);
            RsiMa[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SF,RSIPeriod,RSIPrice,WP,0,y);
            TrendU[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SF,RSIPeriod,RSIPrice,WP,3,y);
            TrendQqe[r] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SF,RSIPeriod,RSIPrice,WP,6,y);
            TrendQqs[r] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SF,RSIPeriod,RSIPrice,WP,7,y);
            TrendDa[i]  = EMPTY_VALUE;
            TrendDb[i]  = EMPTY_VALUE;
            RsiMaDa[i]  = EMPTY_VALUE;
            RsiMaDb[i]  = EMPTY_VALUE;
      }
      for (i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         if (TrendQqe[r] == -1) PlotPoint(i,RsiMaDa,RsiMaDb,RsiMa);
         if (TrendQqs[r] == -1) PlotPoint(i,TrendDa,TrendDb,TrendU);
      }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i]   = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}